;*****************
; Reseter digi 
;*****************
sjmp go

;**************
;    PORTY
;**************
;
tone	equ 0b0h	;ton trwa - H , bez tonu - L
led	equ 0b7h	;kontrolka LED tonu L-dioda wieci

ptt	equ	094h	;wczenie PTT potwierdzenia aktywny L
signal	equ	093h	;akystyczny sygna potwierdzenia

;
relay_pwr	equ	097h	; przekanik zasilania modemu wczony  H
relay_reset	equ	096h	; przekanik zworki podtrzymania RAM zworka zaoona H
relay_bank	equ	095h	; przekanik banku pamici EPROM BANK 1 - L BANK 0 - H

;***************
; STAE
;**************

kod0	equ	31h ;'1'	;kod dostpu (cyfry w apostrofach)
kod1	equ	33h  ;'2'	;teraz ustawiony jako 1234
kod2	equ	32h  ;'3'
kod3	equ	31h ;'4'

;*************
;   R A M
;*************




;******** gwna ptla ********


ext:	ajmp exit

go:
				
nxt:		jnb tone,$	;czeka na ton
		clr led		; zapala kontrolke LED
		acall zamiana
		cjne a,#kod0,ext	;sprawdza kod0
		jb tone,$
		setb led	;gasi kontrolke LED
		
		jnb tone,$	;czeka na ton
		clr led		; zapala kontrolke LED
		acall zamiana
		cjne a,#kod1,ext	;sprawdza kod1
		jb tone,$
		setb led
		
		jnb tone,$	;czeka na ton
		clr led		; zapala kontrolke LED
		acall zamiana
		cjne a,#kod2,exit	;sprawdza kod2
		jb tone,$
		setb led
		
		jnb tone,$	;czeka na ton
		clr led		; zapala kontrolke LED
		acall zamiana
		cjne a,#kod3,exit	;sprawdza kod3
		jb tone,$
		setb led

					;tutaj kod jest OK


		jnb tone,$	;czeka na ton
		clr led		; zapala kontrolke LED
		acall zamiana
		cjne a,#30h,next_com	;sprawdza komende 0
		jb tone,$
		setb led
		ajmp command0
next_com:
		cjne a,#31h,next_com1	;sprawdza komende 1
		jb tone,$
		setb led
		ajmp command1		

next_com1:
		cjne a,#32h,exit	;sprawdza komende 2
		jb tone,$
		setb led
		ajmp command2		

command0:
		jnb tone,$	;czeka na ton
		clr led		; zapala kontrolke LED
		acall zamiana
		cjne a,#30h,test01	;sprawdza stan
		clr relay_pwr		;wycza przekanik pwr
		acall potwierdzenie
		sjmp exit
test01:
		cjne a,#31h,exit	;sprawdza stan
		setb relay_pwr		;wcza przekanik pwr
		acall potwierdzenie
		sjmp exit

command1:
		jnb tone,$	;czeka na ton
		clr led		; zapala kontrolke LED
		acall zamiana
		cjne a,#30h,test11	;sprawdza stan
		clr relay_reset		;wycza przekanik reset
		acall potwierdzenie
		sjmp exit
test11:
		cjne a,#31h,exit	;sprawdza stan
		setb relay_reset		;wcza przekanik rst
		acall potwierdzenie
		sjmp exit
command2:
		jnb tone,$	;czeka na ton
		clr led		; zapala kontrolke LED
		acall zamiana
		cjne a,#30h,test21	;sprawdza stan
		clr relay_bank		;wycza przekanik pwr
		acall potwierdzenie
		sjmp exit
test21:
		cjne a,#31h,exit	;sprawdza stan
		setb relay_bank		;wcza przekanik pwr
		acall potwierdzenie

exit:		jb tone,$
		setb led	; gasi kontrolke LED			
		ajmp nxt

;----------------------------------------
zamiana:				
		mov a,p3		;odczytuje z portu p3 dane
		rl a
		rl a
		swap a			;zamienia 4 bity z 8870 na znak ascii

		anl a,#00001111b	;w acc znajduje sie wynik zamiany
		mov dptr,#tabela_ascii
		movc a,@a+dptr
		ret
;-------------------------------------
delay:				;opnienie
		mov r6,#0
		mov r5,#0
	lops:	djnz r5,$
		djnz r6,lops
		ret
;-----------------------------------------
potwierdzenie:
		clr ptt		;wcza nadawanie
		acall delay	
		acall delay
		acall delay
		acall bip
		acall delay
		acall delay
		acall delay
		setb ptt
		ret
;-----------------------------
bip:				;sygna akustyczny		
		mov a,#100	;czestotliwo bipa
		mov b,#100	;dlugo bipa
		acall bipa
		ret
bipa:		mov r4,b
bips:		djnz r5,$
		cpl signal
		mov r5,a
		djnz r4,bips
		setb signal
		ret




;------------------------------------------
;tabele


tabela_ascii:			;zamienia odebrane kody 4bit z MT8870 na kody ascii
	db	44h	;D
	db	38h	;8
	db	34h	;4
	db	23h	;#
	db	32h	;2
	db	30h	;0
	db	36h	;6
	db	42h	;B
	db	31h	;1
	db	39h	;9
	db	35h	;5
	db	41h	;A
	db	33h	;3
	db	2ah	;*
	db	37h	;7
	db	43h	;C
END